<?php
namespace common\models;

use Yii;
use yii\base\Model;
use yii2tech\authlog\AuthLogLoginFormBehavior;
use yii\helpers\Html;
use common\widgets\Alert;
use  yii\web\Session;
use app\models\Users;

/**
 * Login form
 */
class LoginForm extends Model
{
    public $username;
    public $password;
    public $rememberMe = true;
    // public $verifyCode;
    private $_user;


    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['username','password'], 'filter', 'filter' =>  '\yii\helpers\HtmlPurifier::process'],
            // username and password are both required
            [['username', 'password'], 'required'],
            // rememberMe must be a boolean value
            ['rememberMe', 'boolean'],
            // password is validated by validatePassword()
            ['password', 'validatePassword'],
            // ['verifyCode', 'safe'],
        ];
    }

    // public function behaviors()
    // {
    //     return [
    //         'authLog' => [
    //             'class' => AuthLogLoginFormBehavior::className(),
    //             'findIdentity' => 'findIdentity',
    //             'verifyRobotAttribute' => 'verifyCode',

    //         ],
    //     ];
    // }

    public function findIdentity()
    {
        return User::findByUsername($this->username);
    }

    /**
     * Validates the password.
     * This method serves as the inline validation for password.
     *
     * @param string $attribute the attribute currently being validated
     * @param array $params the additional name-value pairs given in the rule
     */
    public function validatePassword($attribute, $params)
    {
        if (!$this->hasErrors()) {
            $user = $this->getUser();
            if (!$user || !$user->validatePassword($this->password)) {
                $this->addError($attribute, 'Username atau Password yang Anda masukan Salah.');
            }
        }
    }

    /**
     * Logs in a user using the provided username and password.
     *
     * @return bool whether the user is logged in successfully
     */
    public function login()
    {
        if ($this->validate()) {
            return Yii::$app->user->login($this->getUser(), $this->rememberMe ? 3600 * 24 * 30 : 0);
        }

        return false;
    }

    /**
     * Finds user by [[username]]
     *
     * @return User|null
     */
    protected function getUser()
    {
        if ($this->_user === null) {
            $this->_user = User::findByUsername($this->username);
        }

        return $this->_user;
    }
    protected function getUsernameCheck()
    {
      if ($this->_user === null) {
          $this->_user = User::findByUsernameUn($this->username);
      }

      return $this->_user;
    }
    
}
